; z80calc... azz@josstix.demon.co.uk
; 11-sf floating-point programmable calculator.
;
; Tidy up---this is nearly 5K!
; >>> redefinition <<<
; value of for loop?
; conditions; make a "sign" word, and use "- sign" for < and >, and "-" for =
; logic ops
; checking heapptr against ramtop
; Drivers for pocket80 keyboard. Perhaps port this to Zen? That would
;  solve several problems... and cause more (>8K then).
; Byte peek and poke.
;  This would allow a "memory editor" to be built.
; More coefficients for log---it only has 6!
; Proper allocation and garbage collection (free if not on the
;  stack, in a variable or bound to a word)
; editing compiled funcs -- read from a memory area??
;  help <word>
;  del <word>
; Generic "look up word" function. hl=name // hl=addr a=type
; compilation---more efficient (00xx is builtin, 0000 nnx6 is number)

; Init.

; Machine-specific switches.
initdisp	equ	siminit
outch		equ	simoutch
inch		equ	siminch

;initdisp	equ	pocketconsoleinit 
;outch		equ	pocketconsoleout
;inch		equ	pocketconsolein

RAMTOP		equ	8000
NORMSCALE	equ	10
STACKDEPTH	equ	20
JSTACKDEPTH	equ	20
MAXUSERFUNCS	equ	40
ZSTACKINIT	equ 	8180
WORDBUFLEN	equ	20

	cpu Z80UNDOC
 	org 0h

; Init Z80
	di
	ld sp,ZSTACKINIT

	call initdisp

; Print welcome message
	ld ix,hellomsg
	call outstr

	ld (k_shiftmode),a	; shifts off on reset
	call resetjstack	; clear jump stack either way

; Check reset value
	ld a,(resetval)
	cp 0b7h
	jr z,noreset
	call reset		; need to do cold reset (lose stack etc.)
	jr startcont
noreset:
	ld hl,0			; immediate mode
	ld (streamptr),hl
startcont:

; Main loop: read words and execute them
mainloop:
	call readword
	ld a,(wordbuf)
execchar:			; misnomer now...
	cp '0'			; Is it a number?
	jr c,execchar1
	cp '9'+1
	jr nc,execchar1
	call getn
	push af
	call stpush
	pop af
	jr mainloop
execchar1:
	cp 27h			; ' = single char literal
	jr nz,execchar1a
	ld a,(wordbuf+1)
	ld h,0
	ld l,a
	call stpushint
	jr mainloop
execchar1a:			; No, is it in the lookup table?
	ld ix,fntab
	ld b,a
execchar2:
	ld l,(ix+0)
	ld h,(ix+1)
	call compword
	jr z,execchar3
	ld a,l
	or h			; If zero entry hit then not found.
	jp z,errbadword
	inc ix
	inc ix
	inc ix
	inc ix
	inc ix
	jr execchar2
execchar3:			; Found in lookup table
	ld a,(ix+2)
	ld l,(ix+3)
	ld h,(ix+4)
	or a
	jr z,execchar8
	cp 2
	jr z,execcharv
	call jphl		; MC function
	jr mainloop
execchar8:			; calc function
	push hl
	ld hl,(streamptr)
	call jpush
	ld hl,100h
	call jpush
	pop hl
	ld (streamptr),hl
	jp mainloop	
execcharv:			; variable - push addr
	call stpushint
	jp mainloop
jphl:	
	jp (hl)			; routine does the ret for us.

; Do cold boot
reset:
	ld ix,resetmsg
	call outstr
	ld a,1			; force alpha mode
	ld (k_shiftmode),a
	call inch
	call outch
	push af
	xor a
	ld (k_shiftmode),a
	ld a,'\n'
	call outch
	pop af
	cp 'y'
	ret nz
; Init settings variables
	ld a,NORMSCALE		; Set scale
	ld (scale),a
	ld hl,heapbase		; Set heap ptr
	ld (heapptr),hl
	ld hl,usermapbase	; Set map ptr
	ld (mapptr),hl
	xor a
	ld (hl),a		; Remove user functions
	inc hl
	ld (hl),a
	ld (scutptr),a		; clear scutptr
	ld (scutptr+1),a
	call resetstack
; Init constants
	ld hl,1			; const1 = 1
	call QFLOAT
	ld hl,const1
	call DSTORE
	call DPUSH
	ld hl,10		; const10 = 10
	call QFLOAT
	ld hl,const10
	call DSTORE
	call DDIV
	ld hl,const.1		; const.1 = const1/const10 = .1
	call DSTORE
	ld hl,0			; const0 = 0
	call QFLOAT
	ld hl,const0
	call DSTORE
	ld hl,2
	call QFLOAT
	ld hl,const2
	call DSTORE

	ld hl,0			; Push 0 streamptr
	call jpush
	ld hl,100h		; and type
	call jpush
	ld hl,initfunc		; Set to execute the init func
	ld (streamptr),hl

	ld a,0b7h
	ld (resetval),a
	ret

resetstack:
	ld hl,stack		; Set stack ptr
	ld (stackptr),hl
	xor a
	ld (stackcounter),a	; 0 items on the stack
	ret

resetjstack:
	ld hl,jstack
	ld (jstackptr),hl
	xor a
	ld (jstackcounter),a
	ret

; compare hl with the wordbuf, uses iy and af
compword:
	ld iy,wordbuf
compwordloop:
	ld a,(iy+0)
	cp (hl)
	ret nz
	or a
	jr z,compwordchk
	ld a,(hl)
	or a
	jr z,compwordchk
	inc iy
	inc hl
	jr compwordloop
compwordchk:
	ld a,(iy+0)
	or (hl)
	ret

; Continue reading a word of which we already have one char in A.
readwordcont:
	ld (wordbuf),a
	ld b,1
	ld ix,wordbuf+1
	jr readwordloop

; Read a word into the buffer.
readword:
	ld b,0
	ld ix,wordbuf
readwordloop:
	push bc
	call getinst
	pop bc
	cp ' '			; check for whitespace
	jr z,readworddone
	cp '\n'
	jr z,readworddone
	cp '\r'
	jr z,readworddone
	cp '\t'
	jr z,readworddone
	or a
	jr z,readworddone
	ld (ix+0),a
	inc ix
	inc b
	ld a,b
	cp WORDBUFLEN
	jr z,readworddone
	jr readwordloop
readworddone:
	xor a
	ld (ix+0),0
	ld ix,wordbuf
	ld a,(ix+0)
	or a
	jr z,readword		; if only whitespace read, try again	
	ret

; The definitions of the MC words.

doclear EQU resetstack

; May want to improve this later.
docoldreset EQU reset

dok0:	ld hl,const0
	jr dok
dok1:	ld hl,const1
	jr dok
dok2:	ld hl,const2
	jr dok
dok10:	ld hl,const10
dok:
	call DLOAD
	jp stpush

doint:
	call stpop
	call QIFIX	; which does FA=int(FA)
	jp stpush

doscale:
	call stpopint
	ld a,l
	ld (scale),a
	ret

dopi:
	ld hl,QPI
	call DLOAD
	jp stpush

doread:
	call stpopint
	call DLOAD
	jp stpush
	
dowrite:
	call stpopint
	push hl
	call stpop
	pop hl
	push hl
	ld de,heapbase
	sbc hl,de
	jp c,errmemprotect
	pop hl
	push hl
	ld de,ramtop
	sbc hl,de
	jp nc,errmemprotect
	pop hl
	call DSTORE
	ret

dovar:
	ld ix,(mapptr)
	ld hl,(heapptr)
	ld (ix+0),l	; write in the name string
	ld (ix+1),h
;--- Using : name
	push ix
	call readword
	pop ix
	ld iy,wordbuf
	ld hl,(heapptr)
dovarloop:
	ld a,(iy+0)
	ld (hl),a
	inc iy
	inc hl
	or a
	jr nz,dovarloop
	ld (ix+3),l		; address
	ld (ix+4),h
	ld de,6
	add hl,de
	ld (heapptr),hl
	ld a,2
	ld (ix+2),a		; type=2
	xor a
	ld (ix+5),a		; last map entry
	inc ix
	inc ix
	inc ix
	inc ix
	inc ix
	ld (mapptr),ix
	ret

docolon:
	ld ix,(mapptr)
	ld hl,(heapptr)
	ld (ix+0),l	; write in the name string
	ld (ix+1),h
;--- Using : name
	push ix
	call readword
	pop ix
	ld iy,wordbuf
	ld hl,(heapptr)
docolonloop:
	ld a,(iy+0)
	ld (hl),a
	inc iy
	inc hl
	or a
	jr nz,docolonloop
	ld (heapptr),hl
;---
	push ix
	call stpopint
	pop ix
	ld (ix+3),l		; address
	ld (ix+4),h
	xor a
	ld (ix+2),a		; type=0
	ld (ix+5),a		; last map entry
	inc ix
	inc ix
	inc ix
	inc ix
	inc ix
	ld (mapptr),ix
	ret

doatan:
	call stpop
	call QATAN
	jp stpush

doexp:
	call stpop
	call QEXP
	jp stpush

doln:
	call stpop
	call QLOG
	jp stpush

dorandom:
	call QRAND
	jp stpush

docos:
	call stpop
	call QCOS
	jp stpush

dosin:
	call stpop
	call QSIN
	jp stpush

dotan:
	call stpop
	call QTAN
	jp stpush

; for if, jstack is old( ret-addr 0100 )new
; for while (func --), jstack is old( ret-addr fn-addr 0000 )new
; for for (ntimes func --), jstack is old( ret-addr fn-addr count 0001 )new

dowhile:
	ld hl,(streamptr)
	call jpush
	call stpopint	; pop the fn to call
	ld (streamptr),hl
	call jpush
	ld hl,0
	call jpush
	ret

dofor:
	ld hl,(streamptr)
	call jpush
	call stpopint
	ld (streamptr),hl
	call jpush
	call stpopint
	dec hl		; kludge
	call jpush
	ld hl,1
	call jpush
	ret

doif:
	call stpopint
	push hl
	call stpopint
	ld a,h
	or l
	pop hl
	ret z
	push hl
	ld hl,(streamptr)
	call jpush
	ld hl,0100h
	call jpush
	pop hl
	ld (streamptr),hl
	ret

doexec:
	ld hl,(streamptr)
	call jpush
	ld hl,100h
	call jpush
	call stpopint
	ld (streamptr),hl
	ret

doright:
	call jpop	; grab the type
	nop
	ld a,h
	or a
	jr nz,dorightif
	ld a,l
	or a
	jr z,dorightwhile
dorightfor:
	call jpop	; pop the count
	ld a,h
	or l
	jr z,dorightforno
	dec hl
	ld (forstore),hl
	call jpop
	push hl
	call jpush
	ld hl,(forstore)
	call jpush
	ld hl,1
	call jpush
	pop hl
	jr dorightgo
dorightforno:
	call jpop
	call jpop
	jr dorightgo
dorightwhile:
	call stpopint
	ld a,h
	or l
	jr z,dorightwhileno
	call jpop	; pop off the function to do again
	push hl
	call jpush	; push it back
	ld hl,0
	call jpush	; push the type back
	pop hl	
	jr dorightgo
dorightwhileno:
	call jpop	; lose the fn to do again
	call jpop	; get the original value back
	jr dorightgo
dorightif:		; calls too, actually!
	call jpop
dorightgo:
	ld (streamptr),hl
	ret

doleft:
	ld c,1			; level counter
	ld hl,(streamptr)
	ld a,h
	or l
	jr nz,doleftinitnocomp
	ld hl,(heapptr)
	ld d,1			; if from inch, compile
	jr doleftinit
doleftinitnocomp:
	ld d,0			; flag: 1 means compile
	ld hl,(streamptr)
doleftinit:
	push hl
doleftfrommem:
	call readword
	call compilewbuf
doleftnocomp:
	ld hl,nleft
	call compword
	jr nz,doleftnotleft
	inc c
	jr doleftfrommem
doleftnotleft:
	ld hl,nright
	call compword
	jr nz,doleftnotright
	dec c
	ld a,c
	or a
	jr z,doleftdone
	jr doleftfrommem
doleftnotright:
	jr doleftfrommem
doleftdone:
	pop hl
	jp stpushint

; write the wordbuf onto the heap, with a space at the end
compilewbuf:
	ld ix,wordbuf
compilewbufloop:
	ld a,(ix+0)
	call compilechar
	inc ix
	or a
	jr nz,compilewbufloop
	ld a,' '
	; fall through
compilechar:
	ld hl,(heapptr)
	ld (hl),a
	inc hl
	ld (heapptr),hl
	ret

docopy:
	call stpop
	call stpush
	jp stpush

dodrop:
	jp stpop

doswap:
	call stpop
	call DPUSH
	call stpop
	call DSWAP
	call stpush
	call DPOP
	jp stpush

doconstchar:		; push next char
	call getinst
	ld h,0
	ld l,a
	jp stpushint

docomma:		; print number
	ld a,'\n'
	call outch
	call stpop
	call outn
	ld a,'\n'
	jp outch

doplus:			; add
	call stpop
	call DPUSH
	call stpop
	call DADD
	jr stpush

doslash:		; fp divide
	call stpop
	call DPUSH
	call stpop
	call DSWAP
	call DDIV
	jr stpush

dostar:			; fp multiply
	call stpop
	call DPUSH
	call stpop
	call DMUL
	jr stpush

dodash:			; subtract
	call stpop
	call DPUSH
	call stpop
	call DSWAP
	call DSUB
	jr stpush

doneg:			; negate
	call stpop
	call MINUSFA
	jr stpush

doconst:		; constant

	ret

doquit:			; quit interpreter
	halt

doputc:			; put character
	call stpopint
	ld a,l
	jp outch

dogetc:			; get character
	call inch
	ld l,a
	ld h,0
	jp stpushint

 ; stack stuff
 ; push FA on to stack
 stpush:
	ld a,(stackcounter)
	inc a
	cp STACKDEPTH
	jp z,errstackfull
	ld (stackcounter),a
	ld bc,6
	ld de,(stackptr)
	ld hl,FA
	ldir
	ld hl,(stackptr)
	ld de,6
	add hl,de
	ld (stackptr),hl
	ret

 ; pop stack into FA
 stpop:
	ld a,(stackcounter)
	or a
	jp z,errstackempty
	dec a
	ld (stackcounter),a
	ld de,6
	ld hl,(stackptr)
	xor a	; clear carry
	sbc hl,de
	ld (stackptr),hl
	ld de,FA
	ld bc,6
	ldir
	ret

 ; push int in HL
 stpushint:
	call QFLOAT
	jr stpush

 ; pop int into HL
 stpopint:
	call stpop
	call QIFIX
	ret

; push HL onto the j stack
jpush:
	ld ix,(jstackptr)
	ld (ix+0),l
	ld (ix+1),h
	inc ix
	inc ix
	ld (jstackptr),ix
	ld a,(jstackcounter)
	inc a
	cp JSTACKDEPTH
	jp z,errtoodeep
	ld (jstackcounter),a
	ret

; pop HL off the j stack
jpop:
	ld a,(jstackcounter)
	cp 0
	jp z,errtooshallow
	dec a
	ld (jstackcounter),a
	ld ix,(jstackptr)
	dec ix
	dec ix
	ld l,(ix+0)
	ld h,(ix+1)
	ld (jstackptr),ix
	ret

 ; Slightly nastier stream stuff.

 ; Getinst gets the next char in the instruction stream. This
 ; can be from memory or from inch, depending on streamptr.
 ; If from inch, the char is echoed.
getinst:
	ld a,(streamptr)
	ld b,a
	ld a,(streamptr+1)
	or b
	jr z,getinstkey
	push hl
	ld hl,(streamptr)
	ld a,(hl)
	inc hl
	ld (streamptr),hl
	pop hl
	ret
getinstkey:
	ld a,(scutptr)
	ld b,a
	ld a,(scutptr+1)
	or b
	jr z,getinstkeyr
	ld hl,(scutptr)
getinstscut:
	ld a,(hl)
	or a
	jr nz,getinstkeyn
	ld (scutptr),a
	ld (scutptr+1),a
	jr getinstkeyr
getinstkeyn:
	inc hl
	ld (scutptr),hl
	jp outch
getinstkeyr:
	call inch
	ld b,a
	ld hl,shortcuts
getinstkeylp:
	ld a,(hl)
	inc hl
	or a
	jr z,getinstkeyns
	cp b
	jr z,getinstkeyfound
getinstkeylp2:
	ld a,(hl)
	inc hl
	or a
	jr nz,getinstkeylp2
	jr getinstkeylp
getinstkeyfound:
	ld (scutptr),hl
	jr getinstscut
getinstkeyns:
	ld a,b
	jp outch		; echo char pressed

; Dead simple output stuff.

;---Simulator drivers

siminit:
	ret

; Output char in A.
simoutch:
	out (0h),a
	ret

; Input char to A.
siminch:
	in a,(0h)
	ret

;---Pocket80 drivers

; Driver for pocket80 "console". Provides the console routines.

; Routine constants, and special character values.
K_no_key:	EQU 	0FFh		; "no key pressed" rawcode
K_bad_key:	EQU		0FEh		; "unknown key pressed" rawcode
K_deb_lenA:	EQU		0F0h		; length of debounce delay on keydown		F0h
K_deb_lenB:	EQU		60h			; length of debounce delay on keyup			60h
K_shift:	EQU		0h			; shift sushicode

; (0,X)r is the keyboard, cooked to ASCII.
; (0,0)w is an ASCII dumb tty on the display, supporting 12 to clear the screen.
; (0,1)w is raw characters to the display.
; (0,2)w is raw commands to the display.

; Keypad stuff
; Routines:	k_getraw
;					Get a raw keypress from the keypad.
;			k_conv	Index off a table pointed to by BC.
;			k_get	Convert a keypress, handling the control modes.
;			k_tab1	(table) "Normal" mode keytops
;			k_tab2	(table) "Shift" mode keytops
;			k_tab3	(table)	"Control" mode keytops
;			k_shiftmode
;			k_clearmode
;					Light or clear the LED.

k_getraw:	
		PUSH BC
k_gr1:		IN A,(0h)		; Wait for the first key
		AND 00011111b
		JR Z,k_gr1
		CALL keyblink	; "Debounce."
		LD B,0h
k_gr2:		IN A,(0h)		; Now start reading.
		AND 00011111b
		JR Z,k_gr3
		OR B
		LD B,A
		JR k_gr2
k_gr3:		CALL keyblink
		LD A,B
		POP BC
		RET
     
k_conv:		PUSH HL
		LD L,A
		LD H,0h
		ADD HL,BC
		LD A,(HL)
		POP HL
		RET

; New method (intelligent shifts):
; The "alpha" shift is sticky, but the "inverse" shift is one-shot.

k_sget:
	call k_getraw
	push af
	ld bc,k_tab1	; normal mode
	ld a,(k_shiftmode)
	or a
	jr z,k_sget_cont
	ld bc,k_tab3	; alpha mode
k_sget_cont:
	pop af
k_sget_doconv:
	call k_conv
	or a		; normal mode
	jr z,k_sget_norm
	cp 1h		; inverse mode
	jr z,k_sget_inv
	cp 2h		; alpha mode
	ret nz		; no? then we must have a good keypress!
	ld a,1		; set shiftmode=1
	ld (k_shiftmode),a
	jr k_sget
k_sget_inv:
	call k_getraw
	ld bc,k_tab2
	jr k_sget_doconv
k_sget_norm:
	ld (k_shiftmode),a
	jr k_sget

; Keymap tables.
; -=- New CalcZ80 style

k_tab1: db "@1234567890,A .L",1," I CT RGJP E",2," N"	; normal mode
k_tab2: db "@ W X|    YZB %M",0," V DU SHKQ F",2," O"	; inverse mode
k_tab3: db "@usgoqnbevt,a :m",1,"hkjczyxilrwd",0,"fp"	; alpha mode

; LCD display stuff, loosely based on lcd.i.
; Routines: l_init  set up the LCD
;           l_cmd   output a command
;           l_char  output a character
;           l_out   output a nibble (internal)
;
; This requires general.i (for g_blink).

l_init:
        LD A,00110011b  ; Set 8 bits (twice)
        CALL l_cmd
        LD A,0010b      ; Set 4 bits
        CALL l_out
        LD A,00101000b  ; 4 bits, 1/16th duty, 5x7
        CALL l_cmd
        LD A,00000110b  ; Inc adr upon data
        CALL l_cmd
        LD A,00001110b  ; Turn display & cursor on
        CALL l_cmd
        CALL l_cls
        RET

        ; This assumes the command is 8 bits in A.
        ; Port 0 - 0-3=d4-7, 4=RS, 5=E. 6-7 should be kept LOW! RS: 0=inst, 1=char. E _/~\_
l_cmd: 	PUSH DE
        LD D,A
        AND 0F0h         ; High bits first
        rrca
        rrca
        rrca
        rrca
        CALL l_out
        LD A,D
        AND 0Fh
        CALL l_out
        LD A,D
        POP DE
        RET

l_char:
        PUSH DE
        LD D,A
        AND 0F0h         ; High bits first
        rrca
        rrca
        rrca
        rrca
        OR 10h
        CALL l_out
        LD A,D
        AND 0Fh
        OR 10h
        CALL l_out
        LD A,D
        POP DE
        RET

        ; This outputs A to port 0h, pulsing E (bit 5, $20).
l_out:  OR 01000000b		; serial output mask
		OUT (0h),A
		CALL keyblink
        OR 20h
        OUT (0h),A
		CALL keyblink
        AND 11011111b
        OUT (0h),A
		CALL keyblink
        RET

l_cls:  PUSH AF
        LD A,01h
        CALL l_cmd
		CALL keyblink
		LD A,11000000b	; line 2 locate
        CALL l_cmd
		XOR A			; clear X pos
		LD (v_xcoord),A
        POP AF
        RET

; Do a CR.
dolcdcr:
		PUSH AF
		PUSH HL
		PUSH BC
;		LD A,(v_ycoord)
;		INC A
;		CP 2
;		JR NZ,dolcdcr2
;		CALL k_get		; wait if two lines have been printed without a key
;		XOR A
;dolcdcr2: 
;		LD (v_ycoord),A
		CALL l_cls		; clear the screen.
		LD A,80h		; locate top left
		CALL l_cmd
		LD C,20
		LD HL,lcdbuf
lclrlp:	LD A,(HL)		; write out to top line...
		CALL l_char
		LD A,20h		; and clear the buffer.
		LD (HL),A
		INC HL
		DEC C
		JR NZ,lclrlp
		XOR A
		LD (v_xcoord),A
		LD A,0c0h		; locate on second line.
		CALL l_cmd
		POP BC
		POP HL
        POP AF
		RET

dobackspace:
		PUSH AF
		PUSH BC
		LD A,(v_xcoord)
		OR A
		RET Z		; can't delete back over the end of a line yet!
		DEC A
		LD (v_xcoord),A
		LD B,0h
		LD C,A
		LD HL,lcdbuf
		ADD HL,BC
		LD A,20h
		LD (HL),A
		LD A,00010000b
		CALL l_cmd ; "shift left"
		LD A,20h
		CALL l_char
		LD A,00010000b
		CALL l_cmd ; "shift left"
		POP BC
		POP AF
		RET

keyblink:
        PUSH DE
        LD E,0FFh
kgbloop:
		DEC E
        JR NZ,kgbloop
        POP DE
		RET

startupdelay:
	ld hl,1000h
startupdelayloop:
	dec hl
	ld a,h
	or l
	jr nz,startupdelayloop
	ret

pocketconsoleinit:
		call startupdelay
		ld a,' '		; clear out the buffer
		ld ix,lcdbuf
		ld b,40
pcinitloop0:
		ld (ix+0),a
		inc ix
		djnz pcinitloop0 
		LD A,01000000b
		OUT (0h),A
		LD BC,8000h
pcinitloop:
		DEC BC
		LD A,B
		OR C
		JR NZ,pcinitloop
		LD A,01000000b
		OUT (0h),A
		XOR A
		LD (v_ycoord),A		; used to track number of CRs done since last key.
		CALL l_init
		RET

pocketconsolein: 
	push bc
	push de
	push hl
	push ix
	call k_sget
	pop ix
	pop hl
	pop de
	pop bc
	ret

pocketconsoleout:
;		LD A,(unit)			; Check the unit number. 0=cooked, 1=raw char, 2=raw cmd.
;		OR A
;		JR NZ,notunit0
;		LD A,C   CalcZ80 uses A, not C
		ld c,a
		CP 12		; cls
		JP Z,l_cls
		CP 10		; line feed, ignore
; RET Z   CalcZ80 uses \n, not \r, but this now supports both
		jp z,dolcdcr
		CP 13		; CR, shift display up and home cursor, and clear bottom line.
		JP Z,dolcdcr
		CP 8		; backspace   CalcZ80 never, ever uses this!
		JP Z,dobackspace
		PUSH IX
		LD IX,lcdbuf
		PUSH BC
		LD B,0h
		PUSH AF
		LD A,(v_xcoord)
		LD C,A
		POP AF
		ADD IX,BC
		POP BC
		PUSH AF
		LD (IX+0),A
		CALL l_char
		LD A,(v_xcoord)
		INC A
		LD (v_xcoord),A
		CP 20
		CALL Z,dolcdcr
		POP AF
		POP IX
		RET
;notunit0:
;		CP 2h
;		JR NZ,unit2
;		LD A,C
;		JP l_char
;unit2:	LD A,C
;		JP l_cmd

;pocketconsolest: 		
;		IN A,(0h)
;		AND 00011111b
;		RET Z
;		LD A,0FFh
;		RET

; And, at last...
;ttyinit:	EQU pocketconsoleinit
;ttyout:		EQU pocketconsoleout
;ttyin:		EQU pocketconsolein
;ttyst:		EQU pocketconsolest




;---Generic stuff again
; Output C string at IX.
outstr:	ld a,(ix+0)
	or a
	ret z
	inc ix
	call outch
	jr outstr

; Nasty output stuff. Output FA, a float.
; This is still *far* too slow on the simulator (on the 486, anyway!), 
; but OK on a 4MHz Z80.
outn:
	call handleneg
	call divfaten
	call prescale
	call formatn
	ld a,(outexp)
	or a
	jr z,outnsci
	ld b,a
	ld a,(scale)
	dec a
	cp b
	jr c,outnsci
	ld a,(outexpsign)
	cp '+'
	jr z,outnpos

outnneg:
	; output number when exponent negative
	; this means we have to pad with (exp) zeros, then print
	; digits
	ld a,(scale)
	ld e,a
	ld a,'.'
	call outch
	ld a,(outexp)
	dec a
	jr z,outnnegg
	ld b,a
	ld a,'0'
outnnegl:
	call outch
	dec e
	ret z
	djnz outnnegl
outnnegg:
	ld ix,(outstore)
outnnegll:
	ld a,(ix+0)
	or a
	ret z
	call outch
	dec ix
	dec e
	ret z
	jr outnnegll

outnpos:
	; exponent positive
	; print digits as we have them, inserting the . in the right place
	ld a,(scale)
	ld e,a
	ld d,255
	ld ix,(outstore)
outnposl:
	nop
	ld a,(ix+0)
	or a
	ret z
	call outch
	dec ix
	dec e
	ret z
	inc d
	ld a,(outexp)
	cp d
	jr nz,outnposl
	ld a,'.'
	call outch
	jr outnposl
	
outnsci:
	ld a,(scale)
	ld b,a
	ld ix,(outstore)
	ld a,(ix+0)
	call outch
	dec ix
	dec b
	ld a,'.'
	call outch
outnscil:
	ld a,(ix+0)
	or a
	jr z,outnexp
	call outch
	dec ix
	dec b	; have we printed (scale) digits yet?
	jr z,outnexp
	jr outnscil
outnexp:
	ld a,(outexp)
	or a
	ret z
	; output exponent
	ld a,'e'
	call outch
	ld a,(outexpsign)
	call outch
	ld a,(outexp)
	call outbyte
	ret

; Macro to use the compares: DLT DLE DGT DGE DEQ DNE
; with is the address of a constant
; nz return means true
DoCompare MACRO type,with
	call DPUSH
	call DPUSH
	ld hl,with
	call DLOAD
	call type
	ld a,l
	call DPOP
	or a
	ENDM

; Do prescaling on FA and set (outexp) and (outexpsign) accordingly.
prescale:
	xor a
	ld (outexp),a		; abs
	ld a,'+'		; by default exp is positive
	ld (outexpsign),a	; 1 means negative
	DoCompare DEQ,const0
	ret nz			; FA=0, so nothing needed
	DoCompare DLT,const1
	jr nz,prescalegrow
prescaleshrink:			; FA>=1, make it smaller
	call divfaten
	call incoutexp
	DoCompare DLT,const1
	jr z,prescaleshrink
	ret
prescalegrow:			; FA<1, maybe make it bigger
	DoCompare DGE,const.1
	jr nz,prescaledone
	call mulfaten
	call incoutexp
	jr prescalegrow
prescaledone:
	ld a,'-'		; it was small, so the exp is negative
	ld (outexpsign),a
	ret

; FA=FA/10
divfaten:
	call DPUSH
	ld hl,const10
	call DLOAD
	call DDIV
	ret

; (outexp)++
incoutexp:
	ld a,(outexp)
	inc a
	ld (outexp),a
	ret

handleneg:
; If it's <0, then print a - first and negate.
	DoCompare DLT,const0
	ret z
	call MINUSFA
	ld a,'-'
	call outch
	ret

; Output the fraction part of FA to SCALE dp into the buffer.
formatn:		; Entry point without negate.
	ld a,(scale)	; Multiply FA by 10^SCALE.
	ld b,a
outn0:
	push bc
	call mulfaten
	pop bc
	djnz outn0
	;
	ld ix,outbuf	; Write a zero into the first byte of outbuf.
	xor a
	ld (ix+0),a
	ld (outcount),a
	ld (outstore),ix
outn1:			; replaces original call to modfaten: much faster!
;	fmod(z,x) = z-x*floor(z/x)
;	fmod(z,10) = z-10*floor(z/10)
; HL=FA%10
	ld hl,modstore	; store z into modstore
	call DSTORE
	call DPUSH
	ld hl,const10
	call DLOAD
	call DDIV	; FA=z/10
	ld hl,modstore2 ; put z/10 into modstore2
	call DSTORE
	call QFLOOR	; FA=int(FA)=int(z/10)
	call DPUSH	; FA=10*FA=10*int(z/10)
	ld hl,const10
	call DLOAD
	call DMUL
	call DPUSH
	ld hl,modstore
	call DLOAD
	call DSWAP	; FA=10*int(z/10), TOS=z
	call DSUB	; FA=z-10*int(z/10)
	call QIFIX	; HL=int(FA)
	ld a,'0'
	add a,l
	ld ix,(outstore)
	inc ix
	ld (ix+0),a
	ld (outstore),ix
	ld hl,modstore2
	call DLOAD	; FA=z/10
	ld a,(outcount)
	inc a
	ld (outcount),a
	ld b,a
	ld a,(scale)
	cp b
	jr nz,outn1
	ret


; FA=FA*10
mulfaten:
	push af
	push bc
	call DPUSH
	ld hl,const10
	call DLOAD
	call DMUL
	pop bc
	pop af
	ret

; Output the number in A in decimal.
outbyte:
	ld b,0
outbyte100:
	cp 100
	jr c,outbyte10
	sub 100
	inc b
	jr outbyte100
outbyte10:
	push af
	ld a,'0'
	add a,b
	call outch
	pop af
	ld b,0
outbyte10l:
	cp 10
	jr c,outbyte1
	sub 10
	inc b
	jr outbyte10l
outbyte1:
	push af
	ld a,'0'
	add a,b
	call outch
	pop af
	add a,'0'
	call outch
	ret

; Input a number using getinst. First digit is in A already.
getn:
	ld ix,wordbuf
	ld (getnptr),ix
	ld hl,0
	call QFLOAT
getncont:
	call getngetc
	cp '.'
	jr z,getndot
	cp 'e'
	jr z,getne
	cp '0'
	jr c,getndone
	cp '9'+1
	jr nc,getndone
	sub '0'
	call mulfaten
	call DPUSH
	ld h,0
	ld l,a
	call QFLOAT
	call DADD
	jr getncont
getndot:
	call DPUSH
	ld hl,const.1
	call DLOAD
	ld hl,getnmul
	call DSTORE
	call DPOP
getndl:
	nop
	call DPUSH
	call getngetc
	cp '0'
	jr c,getnldone
	cp '9'+1
	jr nc,getnldone
	sub '0'
	ld h,0
	ld l,a
	call QFLOAT
	call DPUSH
	ld hl,getnmul
	call DLOAD
	call DMUL
	call DADD
	call DPUSH
	ld hl,getnmul
	call DLOAD
	call divfaten
	ld hl,getnmul
	call DSTORE
	call DPOP
	jr getndl
getnldone:
	call DPOP
getne:
getndone:
	ret

getnmul: ds 6

getngetc:
	ld ix,(getnptr)
	ld a,(ix+0)
	inc ix
	ld (getnptr),ix
	ret

; Floating point stuff from the SmallCPlus float library.

; Stuff needed to get the below to compile.

; Overflow in QIFIX: return 32767 in HL.
OFLOWfix:
	ld hl,32767
	ret

errtoodeep:
	call resetjstack
	ld ix,errortd
	jr doerr
errtooshallow:
	call resetjstack
	ld ix,errorts
	jr doerr
errmemprotect:
	ld ix,errormp
	jr doerr
errbadword:
	ld ix,errorbw
	jr doerr
errstackfull: 
	ld ix,errorsf
	jr doerr
errstackempty:
	ld ix,errorse
	jr doerr
DIVZERO: 
	ld ix,errordz
	jr doerr
OFLOW:
	ld ix,errorof
	jr doerr	
ILLFCT:
	ld ix,errorif
doerr:	
	ld sp,ZSTACKINIT	; reset the Z80 stack
	push ix
	ld a,'\n'
	call outch
	ld ix,wordbuf
	call outstr
	ld a,':'
	call outch
	pop ix
	call outstr
	ld a,'\n'
	call outch
	ld hl,0			; back to immediate mode
	ld (streamptr),hl
	jp mainloop

;
;	name...
;		float
;
;	purpose...
;		floating point routines for C programs
;
;	note...
;		This code uses some of the Z-80's UNDOCUMENTED 
;	INSTRUCTIONS. The instructions work because the IX and
;	IY escape bytes are actually a bit more general than
;	Zilog advertises. Note that in the instructions
;		E1	POP HL
;		DD E1	POP IX
;		FD E1	POP IY
;	(which Zilog documents), the opcodes for the IX and IY
;	registers are the same as for the HL register, but are
;	preceded by the escape bytes DD and FD. Similarly,
;		6A	LD L,D
;		DD 6A	LD XL,D		undocumented
;		FD 6A	LD YL,D		undocumented
;	where the new instructions deal with the lower half
;	of the IX and IY registers, respectively. All of the
;	single-byte transfers, and single byte operations such
;	as ADD and INC, involving the H or L registers, can be
;	preceded by escape bytes in this fashion.
;
;	history...
;		The floating point arithmetic routines were
;		written by Neil Colvin and were included in
;		Xitan Disk Basic.  He has consented to release
;		them to the public domain for individual use
;		but not for sale. Disassembly, comments, ifix(),
;		float(), and the interface to c programs were by
;		James R. Van Zandt.
;DLOAD	FA = (hl)
;DLDPSH	FA = (hl), push FA
;DSTORE	(hl) = FA
;DPUSH	push FA
;DSWAP	swap top,FA
;DSUB	FA = pop - FA
;DADD	FA = pop + FA
;DMUL	FA = pop * FA
;DDIV	FA = pop / FA
;MINUSFA FA = -FA
; (These return 1 in HL for true, 0 in HL for false)
;DGE	top >= FA
;DGT	top > FA
;DLE	top <= FA
;DLT	top < FA
;DEQ	top == FA
;DNE	top != FA
;QPI	constant pi
;QHALFPI constant pi/2
;QIFIX	int HL = float FA ; FA=int(FA)
;QFLOAT	float FA = int HL
;QAMAX	FA = max(top,FA)
;QAMIN	FA = min(top,FA)
;QATAN	FA = atan(FA) (?)
;QEXP	FA = e^FA
;QLOG10	FA = log_10(FA)
;QLOG	FA = ln(FA)
;QRAND	FA = random value between 0 and 1
;QCOS	FA = cos(FA)
;QSIN	FA = sin(FA)
;QTAN	FA = tan(FA)

; Adam: The documentation describes this as the best Z80 code the
; author has ever seen. I would personally rank it as most obscure and
; hardest to use!
; QFMOD was broken, so I've removed it and used my own routines.
;
;
EXTRA:	ds	6
FA:	ds	6	;floating point accumulator
FASIGN:	ds	1	;msb indicates sign of FA
;			0 => negative, 1 => positive

;
SEED:	DEFB	80H,80H,0,0,0,0 ;seed for random number generator
;


; DIVZERO: CALL	GRIPE
;	DEFB	"cannot /0",0
; OFLOW:	CALL	GRIPE
;	DEFB	"Arithmetic overflow",0
;ILLFCT:	CALL	GRIPE
;	DEFB	"Illegal function",0
; GRIPE:	CALL	QERR	;top word on stack points to message
; 	JP	0	;error was fatal
;
;	FA = (hl)
;
DLOAD:
	LD	DE,FA
	LD	BC,6
	LDIR
	RET
;
;	load FA from (HL), and push FA onto stack
;
DLDPSH:
	LD	DE,FA
	LD	BC,6
	LDIR
;
;	push the floating point accumulator
;	(preserving return address)
;
DPUSH:
	POP	DE
	LD	HL,(FA+4)
	PUSH	HL
	LD	HL,(FA+2)
	PUSH	HL
	LD	HL,(FA)
	PUSH	HL
	EX	DE,HL
	JP	(HL)

DPOP:
	POP DE	; ret addr
	POP HL
	LD (FA),HL
	POP HL
	LD (FA+2),HL
	POP HL
	LD (FA+4),HL
	EX DE,HL
	JP (HL)

;
;	push floating point accumulator
;	(preserve return address and next stacked word)
;
DPUSH2:	POP	DE	;save return address
	POP	BC	;save next word
	LD	HL,(FA+4)
	PUSH	HL
	LD	HL,(FA+2)
	PUSH	HL
	LD	HL,(FA)
	PUSH	HL
	EX	DE,HL
	PUSH	BC	;restore next word
	JP	(HL)	;return
;
FSUB:	CALL	MINUSFA
	JR	FADD
;
;	subtract the floating point accumulator from the value
;	on the stack (under the return address), leave result
;	in the floating point accumulator.
;
DSUB:	CALL	MINUSFA
;
;	add the value on the stack (under the return address)
;	to the floating point accumulator
;
DADD:	POP	HL	;save return address
	POP	DE
	POP	IX
	POP	BC
	PUSH	HL	;replace return address
;
;	add bc ix de to floating point accumulator
;
FADD:	LD	A,B
	OR	A
	RET	Z	;z => number to be added is zero
	LD	A,(FA+5)
	OR	A
	JP	Z,LDFABC ;z => accumulator is zero,
;				just load number
	SUB	B
	JR	NC,ADD2 ;nc => accumulator has larger number
	NEG		;reverse accumulator & bc ix de...
	EXX
	PUSH	IX
	CALL	LDBCFA
	EXX
	EX	(SP),IX
	CALL	LDFABC
	EXX
	POP	IX	;...end of reversing
ADD2:	CP	29H
	RET	NC	;nc => addition makes no change
	PUSH	AF	;save difference of exponents
	CALL	UNPACK	;restore hidden bit & compare signs
	LD	H,A	;save difference in signs
	POP	AF	;recall difference of exponents
	CALL	RSHIFT	;shift  c ix de b  right by (a)
	OR	H
	LD	HL,FA
	JP	P,ADD4	;p => opposite signs, must subtract
	CALL	FRADD	;c ix de += FA
	JR	NC,PACK	;nc => adding caused no carry
	INC	HL
	INC	(HL)	;increment exponent
	JP	Z,OFLOW
	LD	L,1
	CALL	RSH8	;shift  c ix de b  right by 1
	JR	PACK	;round, hide msb, & load into FA
;
ADD4:	XOR	A	;negate b...
	SUB	B
	LD	B,A
	LD	A,(HL)	;c ix de -= FA...
	SBC	A,E
	LD	E,A
	INC	HL
	LD	A,(HL)
	SBC	A,D
	LD	D,A
	INC	HL
	LD	A,(HL)
	DEFB	0DDH
	SBC	A,L
	DEFB	0DDH
	LD	L,A
	INC	HL
	LD	A,(HL)
	DEFB	0DDH
	SBC	A,H
	DEFB	0DDH
	LD	H,A
	INC	HL
	LD	A,(HL)
	SBC	A,C
	LD	C,A	;...end of subtraction, fall into...
;
;	reverse sign if necessary (cy set) and normalize
;	(sign reversal necessary because we're using
;	sign-magnitude representation rather than
;	twos-complement)
;
NORMA:	CALL	C,MINUSBC
;
;	normalize the 48 bit number in c ix de b
;	current exponent is in FA+5
;
;	result loaded into FA
;
NORM:	LD	L,B
	LD	H,E
	XOR	A
NORM2:	LD	B,A
	LD	A,C
	OR	A
	JR	NZ,NORM12  ;nz => 7 or fewer shifts needed
;			shift c ix d hl  left by one byte
	DEFB	0DDH
	LD	C,H
	DEFB	0DDH
	LD	A,L
	DEFB	0DDH
	LD	H,A
	DEFB	0DDH
	LD	L,D
	XOR	A
	LD	D,H
	LD	H,L
	LD	L,A	;...end of shifting
;
	LD	A,B
	SUB	8	;adjust exponent
	CP	0D0H
	JR	NZ,NORM2
;
NORM4:	XOR	A
NORM6:	LD	(FA+5),A
	RET
;
NORM8:	DEC	B
;			shift  c ix d hl  left one bit...
	ADD	HL,HL
	RL	D
	EX	AF,AF'
	ADD	IX,IX
	EX	AF,AF'
	JR	NC,NORM10
	INC	IX
NORM10:	EX	AF,AF'
	RL	C	;...end of shifting
;
NORM12:	JP	P,NORM8	;p => high order bit still zero
	LD	A,B
;			move number to  c ix de b
	LD	E,H
	LD	B,L
	OR	A
	JR	Z,PACK	;z => exponent unchanged
	LD	HL,FA+5		;update exponent
	ADD	A,(HL)
	LD	(HL),A
	JR	NC,NORM4	;nc => underflow (set to 0)
	RET	Z		;z => underflow (leave as 0)
;
PACK:	LD	A,B
PACK2:	LD	HL,FA+5	;round c ix de b to 40 bits
	OR	A
	CALL	M,INCR
	LD	B,(HL)	;load exponent
	INC	HL
	LD	A,(HL)	;recover sign
	AND	80H	;mask out all but sign
	XOR	C	;add to high
	LD	C,A	;   order byte
	JP	LDFABC	;place answer in FA
;
INCR:	INC	E	;increment c ix de
	RET	NZ
	INC	D
	RET	NZ
	DEFB	0DDH
	INC	L
	RET	NZ
	DEFB	0DDH
	INC	H
	RET	NZ
	INC	C
	RET	NZ	;z => carry
	LD	C,80H	;set high order bit
	INC	(HL)	;   and increment exponent
	RET	NZ
	JP	OFLOW
;
;	fraction add: c ix de += (hl)
;
FRADD:	LD	A,(HL)
	ADD	A,E
	LD	E,A
	INC	HL
	LD	A,(HL)
	ADC	A,D
	LD	D,A
	INC	HL
	LD	A,(HL)
	DEFB	0DDH
	ADC	A,L
	DEFB	0DDH
	LD	L,A
	INC	HL
	LD	A,(HL)
	DEFB	0DDH
	ADC	A,H
	DEFB	0DDH
	LD	H,A
	INC	HL
	LD	A,(HL)
	ADC	A,C
	LD	C,A
	RET
;
;	complement FASIGN and negate the fraction c ix de b
;
MINUSBC: LD	HL,FASIGN
	LD	A,(HL)
	CPL
	LD	(HL),A
	XOR	A
	LD	L,A
	LD	H,A
	SUB	B
	LD	B,A
	LD	A,L
	SBC	HL,DE
	EX	DE,HL
	LD	L,A
	DEFB	0DDH
	SBC	A,L
	DEFB	0DDH
	LD	L,A
	LD	A,L
	DEFB	0DDH
	SBC	A,H
	DEFB	0DDH
	LD	H,A
	LD	A,L
	SBC	A,C
	LD	C,A
	RET
;
;	shift  c ix de b  right by (a)
;
RSHIFT:	LD	B,0
RSH2:	SUB	8
	JR	C,RSH4	;c => 7 or fewer shifts remain
	LD	B,E	;shift  c ix de b  right by 8...
	LD	E,D
	DEFB	0DDH
	LD	D,L
	EX	AF,AF'
	DEFB	0DDH
	LD	A,H
	DEFB	0DDH
	LD	L,A
	EX	AF,AF'
	DEFB	0DDH
	LD	H,C
	LD	C,0	;...end of shifting
	JR	RSH2
;
RSH4:	ADD	A,9
	LD	L,A
RSH6:	XOR	A
	DEC	L
	RET	Z	;z => requested shift is complete
	LD	A,C
RSH8:	RRA		;shift  c ix de b  right by one...
	LD	C,A
	DEFB	0DDH
	LD	A,H
	RRA
	DEFB	0DDH
	LD	H,A
	DEFB	0DDH
	LD	A,L
	RRA
	DEFB	0DDH
	LD	L,A
	RR	D
	RR	E
	RR	B	;...end of shifting
	JR	RSH6
;
;	multiply the floating point accumulator by the value
;	on the stack (under the return address), leave result
;	in the floating point accumulator.
;
DMUL:	POP	HL	;return addr
	POP	DE	;multiplier...
	POP	IX
	POP	BC
	PUSH	HL	;replace return addr
;
;	multiply floating point accumulator by  bc ix de
;
FMUL:	CALL	SGN
	RET	Z	; z => accumulator has zero
	LD	L,0	;"product" flag
	CALL	DIV14	;find exponent of product
	LD	A,C  ;c' h'l' d'e' (multiplicand) = c ix de...
	PUSH	DE
	EXX
	LD	C,A
	POP	DE
	PUSH	IX
	POP	HL
	EXX		;...end of multiplicand loading
	LD	BC,0	; c ix de b (product) = 0...
	LD	D,B
	LD	E,B
	LD	IX,0
	LD	HL,NORM	; push addr of normalize routine
	PUSH	HL
	LD	HL,MULLOOP	; push addr of top of loop
	PUSH	HL	; (5 iterations wanted,
	PUSH	HL	; once per byte of fraction)
	PUSH	HL
	PUSH	HL
	LD	HL,FA	;point to LSB
MULLOOP: LD	A,(HL)	;get next byte of multiplier
	INC	HL
	OR	A
	JR	NZ,MUL2	; z => next 8 bits of multiplier are 0
	LD	B,E	;shift  c ix de b  right by 8...
	LD	E,D
	DEFB	0DDH
	LD	D,L
	EX	AF,AF'
	DEFB	0DDH
	LD	A,H
	DEFB	0DDH
	LD	L,A
	EX	AF,AF'
	DEFB	0DDH
	LD	H,C
	LD	C,A	;...end of shifting
	RET		;go to top of loop or NORM
;
MUL2:	PUSH	HL	;save multiplier pointer
	EX	DE,HL
	LD	E,8	;8 iterations (once per bit)
MUL4:	RRA		;rotate a multiplier bit into cy
	LD	D,A
	LD	A,C
	JR	NC,MUL6	; nc => no addition needed
	PUSH	HL	; c ix hl (product)  +=
	EXX		;	c' h'l' d'e' (multiplicand)
	EX	(SP),HL
	ADD	HL,DE
	EX	(SP),HL
	EX	DE,HL
	PUSH	IX
	EX	(SP),HL
	ADC	HL,DE
	EX	(SP),HL
	POP	IX
	EX	DE,HL
	ADC	A,C
	EXX
	POP	HL
;
MUL6:	RRA	   ;shift  c ix hl b (product)  right by 1...
	LD	C,A
	DEFB	0DDH
	LD	A,H
	RRA
	DEFB	0DDH
	LD	H,A
	DEFB	0DDH
	LD	A,L
	RRA
	DEFB	0DDH
	LD	L,A
	RR	H
	RR	L
	RR	B		;...end of shifting
	DEC	E
	LD	A,D
	JR	NZ,MUL4		; z => 8 iterations complete
	EX	DE,HL
MUL8:	POP	HL		;recover multiplier pointer
	RET			;go to top of loop or NORM
;
DIV1:	POP	BC
	POP	IX
	POP	DE
	JR	FDIV
;
;	divide the value on the stack (under the return
;	address) by the floating point accumulator, leave
;	result in the floating point accumulator.
;
DDIV:	POP	HL	;save return address
	POP	DE
	POP	IX
	POP	BC
	PUSH	HL	;replace return address
;
;	divide  bc ix de  by FA, leave result in FA
;
FDIV:	CALL	SGN
	JP	Z,DIVZERO ; z => attempting to divide by 0
	LD	L,0FFH	;"quotient" flag
	CALL	DIV14	;find quotient exponent
	PUSH	IY
	INC	(HL)
	INC	(HL)
	DEC	HL
	PUSH	HL	; c' h'l' d'e' (divisor) = FA...
	EXX
	POP	HL
	LD	C,(HL)
	DEC	HL
	LD	D,(HL)
	DEC	HL
	LD	E,(HL)
	DEC	HL
	LD	A,(HL)
	DEC	HL
	LD	L,(HL)
	LD	H,A
	EX	DE,HL
	EXX
	LD	B,C	; b iy hl (dividend) = c ix de...
	EX	DE,HL
	PUSH	IX
	POP	IY
	XOR	A	; c ix de (quotient) = 0...
	LD	C,A
	LD	D,A
	LD	E,A
	LD	IX,0
	LD	(EXTRA),A
DIV2:	PUSH	HL	;save b iy hl in case the subtraction
	PUSH	IY	; proves to be unnecessary
	PUSH	BC
	PUSH	HL	; EXTRA b iy hl (dividend)  -=
	LD	A,B	;	c' h'l' d'e' (divisor)...
	EXX
	EX	(SP),HL
	OR	A
	SBC	HL,DE
	EX	(SP),HL
	EX	DE,HL
	PUSH	IY
	EX	(SP),HL
	SBC	HL,DE
	EX	(SP),HL
	POP	IY
	EX	DE,HL
	SBC	A,C
	EXX
	POP	HL
	LD	B,A
	LD	A,(EXTRA)
	SBC	A,0
	CCF
	JR	NC,DIV4	; nc => subtraction caused carry
	LD	(EXTRA),A
	POP	AF	;discard saved value of dividend...
	POP	AF
	POP	AF
	SCF
	JR	DIV6
DIV4:	POP	BC	;restore dividend...
	POP	IY
	POP	HL
;
DIV6:	INC	C
	DEC	C
	RRA
	JP	M,DIV12
	RLA	  ;shift  c ix de a (quotient)  left by 1...
	RL	E
	RL	D
	EX	AF,AF'
	;(these 6 lines are  adc ix,ix...)
	ADD	IX,IX
	EX	AF,AF'
	JR	NC,DIV8
	INC	IX
DIV8:	EX	AF,AF'
	RL	C	;...end of  c ix de a  shifting
	ADD	HL,HL	;shift  EXTRA b iy hl  left by 1...
	EX	AF,AF'
	ADD	IY,IY
	EX	AF,AF'
	JR	NC,DIV9
	INC	IY
DIV9:	EX	AF,AF'
	RL	B
	LD	A,(EXTRA)
	RLA
	LD	(EXTRA),A  ;...end of  EXTRA b iy hl  shifting
	LD	A,C	;test  c ix de...
	OR	D
	OR	E
	DEFB	0DDH
	OR	H
	DEFB	0DDH
	OR	L	;...end of  c ix de  testing
	JR	NZ,DIV2	;nz => dividend nonzero
	PUSH	HL
	LD	HL,FA+5
	DEC	(HL)
	POP	HL
	JR	NZ,DIV2
	JR	OFLOW2
;
DIV12:	POP	IY
	JP	PACK2
;
;	find exponent for product (L=0) or quotient (L=ff)
;
DIV14:	LD	A,B
	OR	A
	JR	Z,DIV20
	LD	A,L	;get product/quotient flag
	LD	HL,FA+5
	XOR	(HL)	;get +-FA exponent
	ADD	A,B	;find and...
	LD	B,A	;...load new exponent
	RRA
	XOR	B
	LD	A,B
	JP	P,DIV18
	ADD	A,80H
	LD	(HL),A
	JP	Z,MUL8
	CALL	UNPACK	;restore hidden bits & compare signs
	LD	(HL),A	;save difference of signs
	DEC	HL	;point to MSB of fraction
	RET
;
DIV17:	CALL	SGN
	CPL
	OR	A
	DEFB	21H	;"ignore next 2 bytes"
DIV18:	OR	A
DIV20:	POP	HL
	JP	P,NORM4
OFLOW2:	JP	OFLOW
;
;	set z & s flags per FA
;
SGN:	LD	A,(FA+5)
	OR	A
	RET	Z
	LD	A,(FA+4)
	DEFB	0FEH	;"ignore next byte"
SETFLGS: CPL
	RLA
	SBC	A,A
	RET	NZ
	INC	A
	RET
;
;	Double precision comparisons
;
;	each compares top of stack
;	(under two return addresses) to FA
;
;TOS >= FA?
DGE:	CALL	DCOMPAR
	JR	Z,YES	;z => equal
	JR	DG	;remaining tests are shared
;
;TOS > FA?
DGT:	CALL	DCOMPAR
	JR	Z,NO	;z => equal
DG:	JP	P,NO	;p => not greater than
YES:	LD	HL,1	;load "true"
	RET
;
;TOS <= FA?
DLE:	CALL	DCOMPAR
	JR	Z,YES
	JR	DL
;
;TOS < FA?
DLT:	CALL	DCOMPAR
	JR	Z,NO
DL:	JP	P,YES	;p => less than
NO:	LD	HL,0	;load "false"
	RET
;
;TOS == FA?
DEQ:	CALL	DCOMPAR
	JR	Z,YES
	JR	NO
;
;TOS != FA?
DNE:	CALL	DCOMPAR
	JR	NZ,YES
	JR	NO
;
;common routine to perform double precision comparisons
DCOMPAR: POP	HL	;save 1st return addr
	POP	IY	;save 2nd return addr
	POP	DE	;get number to compare
	POP	IX
	POP	BC
	PUSH	IY	;replace 2nd addr
	PUSH	HL	;replace 1st addr, fall into...
;
;	sets flags per FA - (bc ix de)
;
COMPARE: LD	A,B
	OR	A
	JR	Z,SGN		;bc ix de = 0, so
;				sign of FA is result

	CALL	SGN
	LD	A,C
	JR	Z,SETFLGS	;FA = 0, so sign of
;				-(bc ix de) is result
	LD	HL,FA+4
	XOR	(HL)
	LD	A,C
	JP	M,SETFLGS	;operands have opposite
;				signs, so result is sign
;				of -(bc ix de)

	CALL	CPFRAC
	RRA			;recover cy bit
	XOR	C	;reverse sign if numbers are negative
	JR	SETFLGS
;
CPFRAC:	INC	HL	;compare  bc ix de  to (HL)
	LD	A,B
	CP	(HL)
	RET	NZ
	DEC	HL
	LD	A,C
	CP	(HL)
	RET	NZ
	DEC	HL
	DEFB	0DDH
	LD	A,H
	CP	(HL)
	RET	NZ
	DEC	HL
	DEFB	0DDH
	LD	A,L
	CP	(HL)
	RET	NZ
	DEC	HL
	LD	A,D
	CP	(HL)
	RET	NZ
	DEC	HL
	LD	A,E
	SUB	(HL)
	RET	NZ
	POP	HL	;return zero to program
	RET		;that called "COMPARE"
;
QFABS:	CALL	SGN
	RET	P
MINUSFA: LD	HL,FA+4
	LD	A,(HL)
	XOR	80H
	LD	(HL),A
	RET
;
PUSHFA:	EX	DE,HL
PUSHF2:	LD	HL,(FA)
	EX	(SP),HL
	PUSH	HL
	LD	HL,(FA+2)
	EX	(SP),HL
	PUSH	HL
	LD	HL,(FA+4)
	EX	(SP),HL
	PUSH	HL
	EX	DE,HL
	RET
;
; Useful constants in C, pi and pi/2
;
QPI:	DW	0A222H	;3.1415926535 = pi
	DW	0FDAH
	DW	8249H
QHALFPI:	DB	022H,0A2H,0DAH,00FH,049H,081H ; pi/2
;
;	exchange floating point accumulator with
;	top of stack (under return address)
;
DSWAP:	POP	HL	;return addr
	POP	DE
	POP	IX
	POP	BC
	EXX		;protect the values
	CALL	DPUSH	;push FA
	EXX		;recover the values
	PUSH	HL	;replace return addr, fall into...
;
;	FA = bc ix de
;
LDFABC:	LD	(FA),DE
	LD	(FA+2),IX
	LD	(FA+4),BC
	RET
;
;	bc ix de = FA
;
LDBCFA:	LD	DE,(FA)
	LD	IX,(FA+2)
	LD	BC,(FA+4)
	RET
;
;	bc ix de = (hl)
;
LDBCHL:	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	C,(HL)
	DEFB	0DDH
	LD	L,C
	INC	HL
	LD	C,(HL)
	DEFB	0DDH
	LD	H,C
	INC	HL
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	RET
;
QSEED:
	LD HL,SEED
;
;	(hl) = FA
;
DSTORE:	LD	DE,FA
	LD	BC,6
	EX	DE,HL
	LDIR
	EX	DE,HL
	RET
;
UNPACK:	LD	HL,FA+4
	LD	A,(HL)	;get MSB of fraction
	RLCA		;rotate sign bit into lsb
	SCF		;set carry
	RRA		;rotate sign bit into cy, cy into msb
	LD	(HL),A	;restore MSB (with hidden bit restored)
	CCF		;complement sign bit...
	RRA
	INC	HL
	INC	HL
	LD	(HL),A	;...and save in msb of FASIGN
	LD	A,C	;similarly, get sign bit of bc ix de...
	RLCA
	SCF
	RRA
	LD	C,A	;...restore hidden bit...
	RRA
	XOR	(HL)	;...and compare with sign of FA.
	RET
;
INT2:	LD	B,A	;if a==0, return with  bc ix de = 0...
	LD	C,A
	LD	D,A
	LD	E,A
	DEFB	0DDH
	LD	H,A
	DEFB	0DDH
	LD	L,A
	OR	A
	RET	Z
	PUSH	HL
	CALL	LDBCFA	;copy FA into bc ix de,
	CALL	UNPACK	; restore hidden bits
	XOR	(HL)
	LD	H,A	;put sign in msb of h
	JP	P,INT4 ;p => positive number
	DEC	DE	;decrement c ix de...
	LD	A,D
	AND	E
	INC	A
	JR	NZ,INT4
	DEC	IX
	DEFB	0DDH
	LD	A,H
	DEFB	0DDH
	AND	L
	INC	A
	JR	NZ,INT4
	DEC	C	;...end of c ix de decrementing
;
INT4:	LD	A,0A8H	;shift  c ix de  right so bits to
	SUB	B	; the right of the binary point
	CALL	RSHIFT	; are discarded
	LD	A,H
	RLA
	CALL	C,INCR	;c => negative, increment  c ix de
	LD	B,0
	CALL	C,MINUSBC ;negate the fraction c ix de
	POP	HL
	RET
;
;	negate FA, and push address of MINUSFA
;	called to evaluate functions f(x) when the argument is
;	negative and f() satisfies f(-x)=-f(x)
ODD:	CALL	MINUSFA
	LD	HL,MINUSFA
	EX	(SP),HL
	JP	(HL)
;
;
;	amax(a,b)	returns the greater of a and b
QAMAX:	LD	HL,8	;offset for 1st argument
	ADD	HL,SP
	CALL	LDBCHL	;bcixde := 1st argument
	CALL	COMPARE
	JP	M,LDFABC
	RET
;
;	amin(a,b)
QAMIN:	LD	HL,8
	ADD	HL,SP
	CALL	LDBCHL
	CALL	COMPARE
	JP	P,LDFABC
	RET
;
;	transcendental floating point routines
;
QATAN:	CALL	SGN	
	CALL	M,ODD		;negate argument & answer
	LD	A,(FA+5)
	CP	81H
	JR	C,ATAN5		;c => argument less than 1
	LD	BC,8100H	;1.0
	LD	IX,0
	LD	D,C
	LD	E,C
	CALL	FDIV	
	LD	HL,HLSUB
	PUSH	HL	;will subtract answer from pi/2
ATAN5:	LD	HL,ATNCOEF
	CALL	EVENPOL
	LD	HL,QHALFPI	;may use for subtraction
	RET	
;
ATNCOEF: DB	13
	DB	14H,7H,0BAH,0FEH,62H,75H
	DB	51H,16H,0CEH,0D8H,0D6H,78H
	DB	4CH,0BDH,7DH,0D1H,3EH,7AH
	DB	1,0CBH,23H,0C4H,0D7H,7BH
	DB	0DCH,3AH,0AH,17H,34H,7CH
	DB	36H,0C1H,0A3H,81H,0F7H,7CH
	DB	0EBH,16H,61H,0AEH,19H,7DH
	DB	5DH,78H,8FH,60H,0B9H,7DH
	DB	0A2H,44H,12H,72H,63H,7DH
	DB	16H,62H,0FBH,47H,92H,7EH
	DB	0C0H,0F0H,0BFH,0CCH,4CH,7EH
	DB	7EH,8EH,0AAH,0AAH,0AAH,7FH
	DB	0F6H,0FFH,0FFH,0FFH,07FH,80H
;
;	transcendental functions: exp
;
QEXP:	LD	BC,8138H	;1.442695041
	LD	IX,0AA3BH
	LD	DE,295CH	
	CALL	FMUL	
	LD	A,(FA+5)
	CP	88H
	JP	NC,DIV17
	CALL	PUSHFA	
	CALL	QFLOOR	
	POP	BC
	POP	IX
	POP	DE
	PUSH	AF
	CALL	FSUB	
	LD	HL,EXPCOEF
	CALL	POLY	
	LD	HL,FA+5	
	POP	AF
	OR	A
	JP	M,EXP5	
	ADD	A,(HL)
	DB	1	;"ignore next 2 bytes"
EXP5:	ADD	A,(HL)
	CCF	
	LD	(HL),A
	RET	NC
	JP	DIV17	
;
EXPCOEF: DB	10
	DB	0CCH,0D5H,45H,56H,15H,6AH
	DB	0CFH,37H,0A0H,92H,27H,6DH
	DB	0F5H,95H,0EEH,93H,00H,71H
	DB	0D0H,0FCH,0A7H,78H,21H,74H
	DB	0B1H,21H,82H,0C4H,2EH,77H
	DB	82H,58H,58H,95H,1DH,7AH
	DB	6DH,0CBH,46H,58H,63H,7CH
	DB	0E9H,0FBH,0EFH,0FDH,75H,7EH
	DB	0D2H,0F7H,17H,72H,31H,80H
	DB	0,0,0,0,0,81H
;
;
;	return -(floor(-x))
QCEIL:	CALL	ODD
;
;	return largest integer not greater than
QFLOOR:	LD	HL,FA+5
	LD	A,(HL)	;fetch exponent
	CP	0A8H
	LD	A,(FA)
	RET	NC	;nc => binary point is right of lsb
	LD	A,(HL)
	CALL	INT2
	LD	(HL),0A8H  ;place binary pt at end of fraction
	LD	A,E
	PUSH	AF
	LD	A,C
	RLA
	CALL	NORMA
	POP	AF
	RET
;
	LD	HL,FA+5
	LD	(HL),0A8H
	INC	HL
	LD	(HL),80H
	LD	A,C
	RLA
	JP	NORMA

; --- QFMOD was here, but it didn't work.
;
;	convert the floating point number in FA
;	to an integer in hl  (rounds toward negative numbers)
;
QIFIX:	CALL	QFLOOR		;take floor first
	LD	HL,0		;initialize the result
	LD	A,(FA+5)	;get the exponent
	LD	B,A		;  and save it
	OR	A
	RET	Z		;z => number was zero
	LD	HL,(FA+3)	;get most significant bits
	LD	C,H		;save sign bit (msb)
	LD	A,B		;get exponent again
	CP	80H+16
	JP	M,IFIX5		;m => fabs(fa) < 32768
	JP	NZ,OFLOWfix	;nz => fabs(fa) > 32768
;				(overflow)
	LD	A,H
	CP	80H
	JP	NZ,OFLOWfix	;nz => fa isn't -32768
	LD	A,L
	OR	A
	JP	NZ,OFLOWfix	;nz => overflow
	RET			;return -32768.
;
IFIX5:	SET	7,H		;restore hidden bit
IFIX6:	SRL	H		;shift right (0 fill)
	RR	L		;shift right (cy fill)
	INC	A
	CP	16+80H
	JR	NZ,IFIX6	;nz => haven't shifted enough
	RL	C
	RET	NC		;nc => positive number
	EX	DE,HL
	LD	HL,1		;compensate for cy bit
	SBC	HL,DE		;negate result
	RET
;
;	transcendental functions: log
;
;
L0F2E:	DEFB	0
;
ONE:	DW	0
	DW	0
	DW	8100H
;
LOGCOEF: DB	6
	DB	23H,85H,0ACH,0C3H,11H,7FH
	DB	53H,0CBH,9EH,0B7H,23H,7FH
	DB	0CCH,0FEH,0A6H,0DH,53H,7FH
	DB	0CBH,5CH,60H,0BBH,13H,80H
	DB	0DDH,0E3H,4EH,38H,76H,80H
	DB	5CH,29H,3BH,0AAH,38H,82H
;
QLOG10:	CALL	QLOG	
	LD	BC,7F5EH	; 1/ln(10)
	LD	IX,5BD8H
	LD	DE,0A938H
	JP	FMUL	
;
QLOG:	CALL	SGN	
	OR	A
	JP	PE,ILLFCT
	LD	HL,FA+5	
	LD	A,(HL)
	LD	BC,8035H	; 1/sqrt(2)
	LD	IX,04F3H
	LD	DE,33FAH
	SUB	B
	PUSH	AF
	LD	(HL),B
	PUSH	DE
	PUSH	IX
	PUSH	BC
	CALL	FADD	
	POP	BC
	POP	IX
	POP	DE
	INC	B
	CALL	FDIV	
	LD	HL,ONE	
	CALL	HLSUB	
	LD	HL,LOGCOEF
	CALL	EVENPOL
	LD	BC,8080H	; -0.5
	LD	IX,0
	LD	DE,0
	CALL	FADD	
	POP	AF
	CALL	L247E	
	LD	BC,8031H	; ln(2)
	LD	IX,7217H
	LD	DE,0F7D2H
	JP	FMUL	
;
;
; don't know what this is, it seems to be part of log()
;
L247E:	CALL	PUSHFA
	CALL	L27EC
	POP	BC
	POP	IX
	POP	DE
	JP	FADD
;
;
L27EC:	LD	B,88H	; 128.
	LD	DE,0
L27F1:	LD	HL,FA+5
	LD	C,A
	PUSH	DE
	POP	IX
	LD	DE,0
	LD	(HL),B	;store exponent
	LD	B,0
	INC	HL
	LD	(HL),80H	;store minus sign
	RLA
	JP	NORMA
;
	EX	DE,HL
	XOR	A
	LD	B,98H
	JR	L27F1
	LD	B,C
L280C:	LD	D,B
	LD	E,0
	LD	HL,L0F2E
	LD	(HL),E
	LD	B,90H
	JR	L27F1
	LD	B,A
	XOR	A
	JR	L280C
;
;
;
;	transcendental floating point routines: polynomial evaluation
;
EVENPOL: CALL	PUSHFA	
	LD	DE,L265F
	PUSH	DE
	PUSH	HL
	CALL	LDBCFA	
	CALL	FMUL	
	POP	HL
;
POLY:	CALL	PUSHFA	
	LD	A,(HL)
	INC	HL
	CALL	DLOAD	
	DB	0FEH	;"ignore next byte"
POL3:	POP	AF
	POP	BC
	POP	IX
	POP	DE
	DEC	A
	RET	Z
	PUSH	DE
	PUSH	IX
	PUSH	BC
	PUSH	AF
	PUSH	HL
	CALL	FMUL	
	POP	HL
	CALL	LDBCHL	
	PUSH	HL
	CALL	FADD	
	POP	HL
	JR	POL3	
;
;
L265F:	POP	BC
	POP	IX
	POP	DE
	JP	FMUL
;
;
ADDHALF: LD	HL,HALF
HLADD:	CALL	LDBCHL
	JP	FADD
HALF:	DEFB	0,0,0,0,0,80H	;0.5
;
HLSUB:	CALL	LDBCHL
	JP	FSUB
;
;
;	convert the integer in hl to
;	a floating point number in FA
;
QFLOAT:	LD	A,H	;fetch MSB
	CPL		;reverse sign bit
	LD	(FASIGN),A ;save sign (msb)
	RLA		;move sign into cy
	JR	C,FL4	;c => nonnegative number
	EX	DE,HL
	SBC	HL,HL	;clear hl
	SBC	HL,DE	;get positive number into hl
FL4:	LD	A,L
	DEFB	0DDH
	LD	H,A	;move LSB to hx
	LD	C,H	;move MSB to c
	LD	DE,0	;clear rest of registers
	LD	B,D
	DEFB	0DDH
	LD	L,D	;clear lx
	LD	A,16+128
	LD	(FA+5),A ;preset exponent
	JP	NORM	;go normalize c ix de b
;
QRAND:
	LD	HL,SEED
	CALL	DLOAD
	LD	BC,9835H	; 11879545.
	LD	IX,447AH
	LD	DE,0
	CALL	FMUL
	LD	BC,6828H	; 3.92767775e-8
	LD	IX,0B146H
	LD	DE,0
	CALL	FADD
	CALL	LDBCFA
	LD	A,E
	LD	E,C
	LD	C,A
	LD	HL,FASIGN
	LD	(HL),80H
	DEC	HL
	LD	B,(HL)
	LD	(HL),80H
	CALL	NORM
	LD	HL,SEED
	JP	DSTORE
;
;	transcendental functions: sin, cos, tan
;
QCOS:	LD	HL,QHALFPI
	CALL	HLADD	
QSIN:	CALL	PUSHFA	
	LD	BC,08349H	;6.283185308... = 2*pi
	LD	IX,00FDAH
	LD	DE,0A222H
	CALL	LDFABC	
	POP	BC
	POP	IX
	POP	DE
	CALL	FDIV	
	CALL	PUSHFA	
	CALL	QFLOOR	
	POP	BC
	POP	IX
	POP	DE
	CALL	FSUB	
	LD	HL,KWARTER
	CALL	HLSUB	
	CALL	SGN	
	SCF	
	JP	P,SIN5	
	CALL	ADDHALF	
	CALL	SGN	
	OR	A
SIN5:	PUSH	AF
	CALL	P,MINUSFA
	LD	HL,KWARTER
	CALL	HLADD	
	POP	AF
	CALL	NC,MINUSFA
	LD	HL,SINCOEF
	JP	EVENPOL
;
KWARTER: DW	0
	DW	0
	DW	7F00H
SINCOEF: DB	7
	DB	90H,0BAH,34H,76H,6AH,82H
	DB	0E4H,0E9H,0E7H,4BH,0F1H,84H
	DB	0B1H,4FH,7FH,3BH,28H,86H
	DB	31H,0B6H,64H,69H,99H,87H
	DB	0E4H,36H,0E3H,35H,23H,87H
	DB	24H,31H,0E7H,5DH,0A5H,86H
	DB	21H,0A2H,0DAH,0FH,49H,83H
;
QTAN:	CALL	PUSHFA	; standard def: tan(x)=sin(x)/cos(x)
	CALL	QSIN	
	POP	BC
	POP	IX
	POP	DE
	CALL	PUSHF2
	EX	DE,HL
	CALL	LDFABC	
	CALL	QCOS	
	JP	DIV1	
;

; -=- Constants

; Messages
;                   ====Width of LCD====
hellomsg: 	db "CalcZ80 0.3 azz '98\n",0
resetmsg: 	db "coldreset (y/n)? ",0
errordz: 	db "Division by zero",0
errorof: 	db "Overflow",0
errorif: 	db "Out of fn range",0
errorsf: 	db "Stack full",0
errorse: 	db "Stack empty",0
errorbw: 	db "Unknown word",0
errormp: 	db "Memory protected",0
errortd: 	db "Flow too deep",0
errorts: 	db "Flow too shallow",0
;                   ====Width of LCD====

; shortcut table
shortcuts:
	db "Atan ",0
	db "Batan ",0
	db "Ccos ",0
	db "Dacos ",0
	db "E/ ",0
	db "Fmod ",0
	db "Gsin ",0
	db "Hasin ",0
	db "Ipi ",0
	db "Jln ",0
	db "Kexp ",0
	db "L- ",0
	db "M] ",0
	db "N+ ",0
	db "O[ ",0
	db "P^ ",0
	db "Qroot ",0
	db "R* ",0
	db "Slog ",0
	db "T^2 ",0
	db "Usqrt ",0
	db ",, ",0
	db "%e ",0
	db ":: ",0
	db "Vdrop ",0
	db "Wswap ",0
	db "Xrot ",0
	db "Ydup ",0
	db "Zpr ",0
	db "|quad , , ",0
	db 0

; -=- Writable data area

resetval: db 0

const0: ds 6
const.1: ds 6
const1: ds 6
const10: ds 6
const2: ds 6

stackptr: 	dw 0
stackcounter:	db 0
jstackptr:	DW 0
jstackcounter:	db 0

scale: 		db 0
outbuf: 	DS 20	; Buffer for number output.
outstore:	DW 0
outcount:	DB 0
outexp:		DB 0	; A signed byte is more than enough.
outexpsign:	DB 0	; 1 for -.

forstore:	DW 0
modstore:	DS 6
modstore2:	DS 6

streamptr:	DW 0
heapptr:	DW 0
scutptr:	DW 0

stack: 		ds STACKDEPTH*6
jstack:		ds JSTACKDEPTH*2

mapptr:		DW 0
getnptr: 	dw 0

; LCD display stuff
v_xcoord:	db 0
v_ycoord:	db 0
lcdbuf:		ds 40
k_shiftmode:	db 0

; Macros for these would be nice...
; Type 0 is a calc function; type 1 is machine code.
fntab:
	dw ncomma
	db 1
	dw docomma
	dw nplus
	db 1
	dw doplus
	dw ndash
	db 1
	dw dodash
	dw nstar
	db 1
	dw dostar
	dw nslash
	db 1
	dw doslash
	dw nneg
	db 1
	dw doneg
	dw nquit
	db 1
	dw doquit
	dw ngetc
	db 1
	dw dogetc
	dw nputc
	db 1
	dw doputc
	dw ncopy
	db 1
	dw docopy
	dw ndrop
	db 1
	dw dodrop
	dw nswap
	db 1
	dw doswap
	dw nright
	db 1
	dw doright
	dw nleft
	db 1
	dw doleft
	dw nexec
	db 1
	dw doexec
	dw nif
	db 1
	dw doif
	dw natan
	db 1
	dw doatan
	dw nexp
	db 1
	dw doexp
	dw nln
	db 1
	dw doln
	dw nrandom
	db 1
	dw dorandom
	dw ncos
	db 1
	dw docos
	dw nsin
	db 1
	dw dosin
	dw ntan
	db 1
	dw dotan
	dw ncolon
	db 1
	dw docolon
	dw nlog
	db 0
	dw cflog
	dw npower
	db 0
	dw cfpower
	dw nroot
	db 0
	dw cfroot
	dw nfac
	db 0
	dw cffac
	dw nread
	db 1
 	dw doread
	dw nwrite
	db 1
	dw dowrite
	dw nquad
	db 0
	dw cfquad
	dw npi
	db 1
	dw dopi
	dw nvar
	db 1
	dw dovar
	dw nscale
	db 1
	dw doscale
	dw nrot
	db 0
	dw cfrot
	dw ne
	db 0
	dw cfe
	dw nint
	db 1
	dw doint
	dw ndeg
	db 0
	dw cfdeg
	dw nrad
	db 0
	dw cfrad
	dw nres
	db 0
	dw cfres
	dw nunres
	db 0
	dw cfunres
	dw nmod
	db 0
	dw cfmod
	dw ncp2
	db 0
	dw cfcp2
	dw nfpart
	db 0
	dw cffpart
	dw nk0
	db 1
	dw dok0
	dw nk1
	db 1
	dw dok1
	dw nk2
	db 1
	dw dok2
	dw nk10
	db 1
	dw dok10
	dw nsquare
	db 0
	dw cfsquare
	dw nmag2
	db 0
	dw cfmag2
	dw nsqrt
	db 0
	dw cfsqrt
	dw nfor
	db 1
	dw dofor
	dw nwhile
	db 1
	dw dowhile
	dw ndice
	db 0
	dw cfdice
	dw ncoldreset
	db 1
	dw docoldreset
	dw npr
	db 0
	dw cfpr
	dw nclear
	db 1
	dw doclear
usermapbase: 
	dw 0
	ds MAXUSERFUNCS*5

ncomma:	db ",",0
nplus:	db "+",0
ndash:	db "-",0
nstar:	db "*",0
nslash:	db "/",0
nneg:	db "neg",0
nquit:	db "quit",0
ngetc:	db "getc",0
nputc:	db "putc",0
ncopy:	db "du","p",0	; remember asl's "dup" bug?
ndrop:	db "drop",0
nswap:	db "swap",0
nright:	db "]",0
nleft:	db "[",0
nexec:	db "exec",0
nif:	db "if",0
natan:	db "atan",0
nexp:	db "exp",0
nln:	db "ln",0
nrandom: db "random",0
ncos:	db "cos",0
nsin:	db "sin",0
ntan:	db "tan",0
ncolon:	db ":",0
nread:	db "@",0
nwrite: db "!",0
npi:	db "pi",0
nvar:	db "var",0
nscale:	db "scale",0
nint:	db "int",0
nk1:	db "k1",0
nk2:	db "k2",0
nk10:	db "k10",0
nk0:	db "k0",0
nfor:	db "for",0
nwhile:	db "while",0
ncoldreset: db "coldreset",0
nclear: db "clear",0

; Function called on initialisation ("cold boot")
initfunc: db "var a var b var c var d var rot1 var rot2 var rot3 ]",0

nlog:	db "log",0
cflog:	db "ln swap ln swap / ]",0

npower:	db "^",0
cfpower: db "swap ln * exp ]",0

nroot:	db "root",0
cfroot: db "swap ln swap / exp ]",0

nfac:	db "fac",0
cffac: 	db "du","p 1 - [ du","p 1 - fac * ] if ]",0

; Quadratic solver - the log func isn't really good enough yet!
; Only manages about 6 sf on (x+1)(x+1) = x^2 + 2x + 1
; Uses vars a through d (d holds discriminant ^ .5)
nquad:	db "quad",0
cfquad:	db "c ! b ! a ! b @ ^2 4 a @ c @ * * - sqrt d ! b @ neg d @ + a @ 2 * / b @ neg d @ - a @ 2 * / ]",0

; rot: ( r1 r2 r3 -- r2 r3 r1 )
nrot:	db "rot",0
cfrot:	db "rot3 ! rot2 ! rot1 ! rot2 @ rot3 @ rot1 @ ]",0  

; e: ( x y -- x*(10^y) )
ne:	db "e",0
cfe:	db "10 swap ^ * ]",0

; dup2: ( x y -- x y x y )
ncp2:	db "dup2",0
cfcp2:	db "swap du","p rot du","p rot swap ]",0

; ideas for functions:
;  deg		( 180 * pi / )
;  rad		( pi * 180 / )
;  res		( len angle -- y x )
;  unres	( y x -- len angle )
;  mod		( x y -- x%y )

ndeg:	db "deg",0
cfdeg:	db "180 * pi / ]",0
nrad:	db "rad",0
cfrad:	db "pi * 180 / ]",0

; square and square root
nsquare: db "^2",0
cfsquare: db "k2 ^ ]",0
nsqrt: db "sqrt",0
cfsqrt: db "k2 root ]",0

; magnitude of a vector
nmag2: db "mag2",0
cfmag2: db "^2 swap ^2 + sqrt ]",0

; resolve and un-resolve vectors
; (x y -- sqrt(x^2+y^2) atan(y/x))
nres:	db "res",0
cfres:	db "dup2 mag2 rot rot swap / atan ]",0

; (len angle -- len*cos(angle) len*sin(angle))
nunres: db "unres",0
cfunres: db "dup2 cos * rot rot sin * ]",0

; ( x -- x-int(x) ) 
nfpart: db "fpart",0
cffpart: db "du","p int - ]",0

; mod ( x y -- x%y ) x%y = y*fpart(x/y)
nmod:	db "mod",0
cfmod:	db "du","p rot swap / fpart * ]",0

; dice roller ( n -- nd6 )
ndice:	db "dice",0
cfdice: db "k0 swap [ random 6 * 1 + int + ] for ]",0

; print top of stack
npr:	db "pr",0
cfpr:	db "du","p , ]",0
	
wordbuf: ds WORDBUFLEN

; We write in data from here...
heapbase:

